// Code generated by "./generator com.deepin.Passkey"; DO NOT EDIT.

// Copyright: 2018 - 2022 UnionTech Software Technology Co., Ltd.
//
// License-Identifier: GPL-3.0-or-later
package Passkey

import (
	"fmt"

	"github.com/godbus/dbus"
	"github.com/linuxdeepin/go-lib/dbusutil"
	"github.com/linuxdeepin/go-lib/dbusutil/proxy"
	"github.com/stretchr/testify/mock"
)

type MockPasskey struct {
	MockInterfacePasskey // interface com.deepin.Passkey
	proxy.MockObject
}

type MockInterfacePasskey struct {
	mock.Mock
}

func (v *MockInterfacePasskey) SetInterfaceName_(string) {
}

// method Claim

func (v *MockInterfacePasskey) GoClaim(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) Claim(flags dbus.Flags) error {
	mockArgs := v.Called(flags)

	return mockArgs.Error(0)
}

// method UnClaim

func (v *MockInterfacePasskey) GoUnClaim(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) UnClaim(flags dbus.Flags) error {
	mockArgs := v.Called(flags)

	return mockArgs.Error(0)
}

// method GetPinStatus

func (v *MockInterfacePasskey) GoGetPinStatus(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) GetPinStatus(flags dbus.Flags) (int32, int32, error) {
	mockArgs := v.Called(flags)

	ret0, ok := mockArgs.Get(0).(int32)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	ret1, ok := mockArgs.Get(1).(int32)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 1, mockArgs.Get(1)))
	}

	return ret0, ret1, mockArgs.Error(2)
}

// method SetPin

func (v *MockInterfacePasskey) GoSetPin(flags dbus.Flags, ch chan *dbus.Call, oldPin string, newPin string) *dbus.Call {
	mockArgs := v.Called(flags, ch, oldPin, newPin)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) SetPin(flags dbus.Flags, oldPin string, newPin string) error {
	mockArgs := v.Called(flags, oldPin, newPin)

	return mockArgs.Error(0)
}

// method Reset

func (v *MockInterfacePasskey) GoReset(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) Reset(flags dbus.Flags) (string, error) {
	mockArgs := v.Called(flags)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method MakeCredential

func (v *MockInterfacePasskey) GoMakeCredential(flags dbus.Flags, ch chan *dbus.Call, user string, credName string, pin string) *dbus.Call {
	mockArgs := v.Called(flags, ch, user, credName, pin)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) MakeCredential(flags dbus.Flags, user string, credName string, pin string) (string, error) {
	mockArgs := v.Called(flags, user, credName, pin)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method GetAssertion

func (v *MockInterfacePasskey) GoGetAssertion(flags dbus.Flags, ch chan *dbus.Call, user string, credName string, pin string) *dbus.Call {
	mockArgs := v.Called(flags, ch, user, credName, pin)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) GetAssertion(flags dbus.Flags, user string, credName string, pin string) (string, error) {
	mockArgs := v.Called(flags, user, credName, pin)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method GetValidCredCount

func (v *MockInterfacePasskey) GoGetValidCredCount(flags dbus.Flags, ch chan *dbus.Call, user string) *dbus.Call {
	mockArgs := v.Called(flags, ch, user)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) GetValidCredCount(flags dbus.Flags, user string) (int32, error) {
	mockArgs := v.Called(flags, user)

	ret0, ok := mockArgs.Get(0).(int32)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// method GetCreds

func (v *MockInterfacePasskey) GoGetCreds(flags dbus.Flags, ch chan *dbus.Call, user string) *dbus.Call {
	mockArgs := v.Called(flags, ch, user)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) GetCreds(flags dbus.Flags, user string) ([]string, error) {
	mockArgs := v.Called(flags, user)

	ret0, ok := mockArgs.Get(0).([]string)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// method GetDeviceCount

func (v *MockInterfacePasskey) GoGetDeviceCount(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) GetDeviceCount(flags dbus.Flags) (int32, error) {
	mockArgs := v.Called(flags)

	ret0, ok := mockArgs.Get(0).(int32)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// method DeviceDetect

func (v *MockInterfacePasskey) GoDeviceDetect(flags dbus.Flags, ch chan *dbus.Call, timeout int32) *dbus.Call {
	mockArgs := v.Called(flags, ch, timeout)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) DeviceDetect(flags dbus.Flags, timeout int32) (string, error) {
	mockArgs := v.Called(flags, timeout)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method DeviceSelect

func (v *MockInterfacePasskey) GoDeviceSelect(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) DeviceSelect(flags dbus.Flags) (string, error) {
	mockArgs := v.Called(flags)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method DeviceSelectClose

func (v *MockInterfacePasskey) GoDeviceSelectClose(flags dbus.Flags, ch chan *dbus.Call) *dbus.Call {
	mockArgs := v.Called(flags, ch)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) DeviceSelectClose(flags dbus.Flags) error {
	mockArgs := v.Called(flags)

	return mockArgs.Error(0)
}

// method DeviceClose

func (v *MockInterfacePasskey) GoDeviceClose(flags dbus.Flags, ch chan *dbus.Call, id string) *dbus.Call {
	mockArgs := v.Called(flags, ch, id)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) DeviceClose(flags dbus.Flags, id string) error {
	mockArgs := v.Called(flags, id)

	return mockArgs.Error(0)
}

// method EncryptKey

func (v *MockInterfacePasskey) GoEncryptKey(flags dbus.Flags, ch chan *dbus.Call, keyType int32) *dbus.Call {
	mockArgs := v.Called(flags, ch, keyType)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) EncryptKey(flags dbus.Flags, keyType int32) (string, error) {
	mockArgs := v.Called(flags, keyType)

	return mockArgs.String(0), mockArgs.Error(1)
}

// method SetSymmetricKey

func (v *MockInterfacePasskey) GoSetSymmetricKey(flags dbus.Flags, ch chan *dbus.Call, encryptType int32, keyType int32, key string) *dbus.Call {
	mockArgs := v.Called(flags, ch, encryptType, keyType, key)

	ret, ok := mockArgs.Get(0).(*dbus.Call)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: 0 failed because object wasn't correct type: %v", mockArgs.Get(0)))
	}

	return ret
}

func (v *MockInterfacePasskey) SetSymmetricKey(flags dbus.Flags, encryptType int32, keyType int32, key string) error {
	mockArgs := v.Called(flags, encryptType, keyType, key)

	return mockArgs.Error(0)
}

// signal ResetStatus

func (v *MockInterfacePasskey) ConnectResetStatus(cb func(id string, finish int32, result string)) (dbusutil.SignalHandlerId, error) {
	mockArgs := v.Called(cb)

	ret0, ok := mockArgs.Get(0).(dbusutil.SignalHandlerId)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// signal MakeCredStatus

func (v *MockInterfacePasskey) ConnectMakeCredStatus(cb func(id string, user string, finish int32, result string)) (dbusutil.SignalHandlerId, error) {
	mockArgs := v.Called(cb)

	ret0, ok := mockArgs.Get(0).(dbusutil.SignalHandlerId)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// signal GetAssertStatus

func (v *MockInterfacePasskey) ConnectGetAssertStatus(cb func(id string, user string, finish int32, result string)) (dbusutil.SignalHandlerId, error) {
	mockArgs := v.Called(cb)

	ret0, ok := mockArgs.Get(0).(dbusutil.SignalHandlerId)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// signal DeviceDetectStatus

func (v *MockInterfacePasskey) ConnectDeviceDetectStatus(cb func(id string, finish int32, result string)) (dbusutil.SignalHandlerId, error) {
	mockArgs := v.Called(cb)

	ret0, ok := mockArgs.Get(0).(dbusutil.SignalHandlerId)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}

// signal DeviceSelectStatus

func (v *MockInterfacePasskey) ConnectDeviceSelectStatus(cb func(id string, finish int32, result string)) (dbusutil.SignalHandlerId, error) {
	mockArgs := v.Called(cb)

	ret0, ok := mockArgs.Get(0).(dbusutil.SignalHandlerId)
	if !ok {
		panic(fmt.Sprintf("assert: arguments: %d failed because object wasn't correct type: %v", 0, mockArgs.Get(0)))
	}

	return ret0, mockArgs.Error(1)
}
